#include <iostream>
#include <vector>

using namespace std;

void dfs(int u, int& br, vector<bool>& posecen, vector< vector<int> >& g) {
	posecen[u] = true;
	br++;
	for(int v : g[u])
		if(!posecen[v])
			dfs(v, br, posecen, g);
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > g(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	int u;
	cin >> u;

	vector<bool> posecen(n);
	int br = 0;
	dfs(u, br, posecen, g);

	cout << br << '\n';
	return 0;
}
